import { Injectable, ɵɵdefineInjectable, Component, ChangeDetectionStrategy, Input, Output, EventEmitter, NgModule, ViewChild } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { A11yModule } from '@angular/cdk/a11y';
import { DragDropModule } from '@angular/cdk/drag-drop';
import { PortalModule } from '@angular/cdk/portal';
import { ScrollingModule } from '@angular/cdk/scrolling';
import { CdkStepperModule } from '@angular/cdk/stepper';
import { CdkTableModule } from '@angular/cdk/table';
import { CdkTreeModule } from '@angular/cdk/tree';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatBadgeModule } from '@angular/material/badge';
import { MatBottomSheetModule } from '@angular/material/bottom-sheet';
import { MatButtonModule } from '@angular/material/button';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import { MatCardModule } from '@angular/material/card';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatChipsModule } from '@angular/material/chips';
import { MatRippleModule, MatNativeDateModule } from '@angular/material/core';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { MatDialogModule } from '@angular/material/dialog';
import { MatDividerModule } from '@angular/material/divider';
import { MatExpansionModule } from '@angular/material/expansion';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatGridListModule } from '@angular/material/grid-list';
import { MatIconModule } from '@angular/material/icon';
import { MatInputModule } from '@angular/material/input';
import { MatListModule } from '@angular/material/list';
import { MatMenuModule } from '@angular/material/menu';
import { MatPaginatorModule } from '@angular/material/paginator';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { MatRadioModule } from '@angular/material/radio';
import { MatSelectModule } from '@angular/material/select';
import { MatSidenavModule } from '@angular/material/sidenav';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatSliderModule } from '@angular/material/slider';
import { MatSnackBarModule } from '@angular/material/snack-bar';
import { MatSortModule } from '@angular/material/sort';
import { MatStepperModule } from '@angular/material/stepper';
import { MatTableModule } from '@angular/material/table';
import { MatTabsModule } from '@angular/material/tabs';
import { MatToolbarModule } from '@angular/material/toolbar';
import { MatTooltipModule } from '@angular/material/tooltip';
import { MatTreeModule } from '@angular/material/tree';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularMaterialSchedulerService = /** @class */ (function () {
    function AngularMaterialSchedulerService() {
    }
    /**
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.checkIfCanUseIntlFormatter = /**
     * @return {?}
     */
    function () {
        return (typeof Intl == 'object' && typeof Intl.DateTimeFormat == 'function');
    };
    /**
     * @param {?} dateIni
     * @param {?} dateEnd
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.calculateHoursBetweenTwoDates = /**
     * @param {?} dateIni
     * @param {?} dateEnd
     * @return {?}
     */
    function (dateIni, dateEnd) {
        return (((dateEnd.getTime() - dateIni.getTime()) / 60) / 60) / 1000;
    };
    /**
     * @param {?} dateToFind
     * @param {?} shifts
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.findShiftsForSpecificDay = /**
     * @param {?} dateToFind
     * @param {?} shifts
     * @return {?}
     */
    function (dateToFind, shifts) {
        if (shifts) {
            /** @type {?} */
            var dateToFindIni = new Date();
            dateToFindIni.setFullYear(dateToFind.getFullYear(), dateToFind.getMonth(), dateToFind.getDate());
            dateToFindIni.setHours(0, 0, 0);
            /** @type {?} */
            var dateToFindEnd = new Date();
            dateToFindEnd.setFullYear(dateToFind.getFullYear(), dateToFind.getMonth(), dateToFind.getDate());
            dateToFindEnd.setHours(23, 59, 59);
            return this.findShiftsForSpecificRange(dateToFindIni, dateToFindEnd, shifts);
        }
        else {
            return [];
        }
    };
    /**
     * @param {?} dateIni
     * @param {?} dateEnd
     * @param {?} shifts
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.findShiftsForSpecificRange = /**
     * @param {?} dateIni
     * @param {?} dateEnd
     * @param {?} shifts
     * @return {?}
     */
    function (dateIni, dateEnd, shifts) {
        if (shifts) {
            /** @type {?} */
            var filteredShifts = shifts.filter((/**
             * @param {?} shift
             * @return {?}
             */
            function (shift) {
                if (dateIni.getTime() <= shift.dateIni.getTime() && dateEnd.getTime() >= shift.dateEnd.getTime())
                    return shift;
            }));
            return filteredShifts;
        }
        else
            return [];
    };
    /**
     * @param {?} dateIni
     * @param {?} dateEnd
     * @param {?} shifts
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.findShiftsForSpecificRangeOfHours = /**
     * @param {?} dateIni
     * @param {?} dateEnd
     * @param {?} shifts
     * @return {?}
     */
    function (dateIni, dateEnd, shifts) {
        if (shifts) {
            /** @type {?} */
            var filteredShifts = shifts.filter((/**
             * @param {?} shift
             * @return {?}
             */
            function (shift) {
                if (dateIni.getTime() <= shift.dateIni.getTime() && dateEnd.getTime() >= shift.dateIni.getTime())
                    return shift;
            }));
            return filteredShifts;
        }
        else
            return [];
    };
    /**
     * @param {?} date
     * @param {?} locale
     * @param {?} format
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.formatDate = /**
     * @param {?} date
     * @param {?} locale
     * @param {?} format
     * @return {?}
     */
    function (date, locale, format) {
        /** @type {?} */
        var formatter = new Intl.DateTimeFormat(locale, format);
        return formatter.format(date);
    };
    /**
     * @param {?} locale
     * @param {?=} startOnSunday
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.getDayNameLabelByLocale = /**
     * @param {?} locale
     * @param {?=} startOnSunday
     * @return {?}
     */
    function (locale, startOnSunday) {
        if (startOnSunday === void 0) { startOnSunday = false; }
        /** @type {?} */
        var starter = startOnSunday ? 4 : 5;
        /** @type {?} */
        var weekDays = [];
        /** @type {?} */
        var date = new Date(0);
        for (var i = 0; i < 7; i++) {
            date.setDate(starter + i);
            /** @type {?} */
            var weekday = this.formatDate(date, locale, { weekday: "short" });
            weekDays.push(weekday);
        }
        return weekDays;
    };
    /**
     * @param {?} date
     * @param {?} startOnSunday
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.getFirstOfWeek = /**
     * @param {?} date
     * @param {?} startOnSunday
     * @return {?}
     */
    function (date, startOnSunday) {
        // Delete reference
        /** @type {?} */
        var currentDate = new Date(date.getTime());
        /** @type {?} */
        var offset = currentDate.getDate() - currentDate.getDay() + (startOnSunday ? -1 : 0) + (currentDate.getDay() == 0 ? -6 : 1);
        /** @type {?} */
        var firstOfWeek = new Date(currentDate.setDate(offset));
        return firstOfWeek;
    };
    /**
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.getScrollbarWidth = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var outer = document.createElement("div");
        outer.style.visibility = "hidden";
        outer.style.width = "100px";
        outer.style.msOverflowStyle = "scrollbar"; // needed for WinJS apps
        document.body.appendChild(outer);
        /** @type {?} */
        var widthNoScroll = outer.offsetWidth;
        // force scrollbars
        outer.style.overflow = "scroll";
        // add innerdiv
        /** @type {?} */
        var inner = document.createElement("div");
        inner.style.width = "100%";
        outer.appendChild(inner);
        /** @type {?} */
        var widthWithScroll = inner.offsetWidth;
        // remove divs
        outer.parentNode.removeChild(outer);
        return widthNoScroll - widthWithScroll;
    };
    /**
     * @param {?} date
     * @param {?} locale
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.getShortDayNameForSpecificDay = /**
     * @param {?} date
     * @param {?} locale
     * @return {?}
     */
    function (date, locale) {
        return this.formatDate(date, locale, { weekday: "short" });
    };
    /**
     * @param {?} date
     * @param {?} hourAmount
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.increaseHoursToSpecificDate = /**
     * @param {?} date
     * @param {?} hourAmount
     * @return {?}
     */
    function (date, hourAmount) {
        date.setTime(date.getTime() + (hourAmount * 60 * 60 * 1000));
        return date;
    };
    /**
     * @param {?} element
     * @param {?} x
     * @param {?} y
     * @return {?}
     */
    AngularMaterialSchedulerService.prototype.scrollContentTo = /**
     * @param {?} element
     * @param {?} x
     * @param {?} y
     * @return {?}
     */
    function (element, x, y) {
        // TODO: Check if we can anim it.
        setTimeout((/**
         * @return {?}
         */
        function () {
            element.scrollTo(x, y);
        }), 500);
    };
    AngularMaterialSchedulerService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AngularMaterialSchedulerService.ctorParameters = function () { return []; };
    /** @nocollapse */ AngularMaterialSchedulerService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AngularMaterialSchedulerService_Factory() { return new AngularMaterialSchedulerService(); }, token: AngularMaterialSchedulerService, providedIn: "root" });
    return AngularMaterialSchedulerService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularMaterialSchedulerComponent = /** @class */ (function () {
    function AngularMaterialSchedulerComponent(ams) {
        this.ams = ams;
        /**
         * Defines the kind of view the library is going to show. By default month view.
         */
        this.view = "month";
        /**
         * Defines the locales the currentDate will use. By default the library uses en-us.
         * For additional information about the posible locales, please visit: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl#Locale_identification_and_negotiation
         */
        this.locale = "en-us";
        /**
         * Defines if the views have to start at sunday or monday. By default, true
         */
        this.startsOnSunday = true;
        /**
         * Defines the date that the calendar will use. If no argument is passed through the input. It will uses Date();
         */
        this.date = new Date();
        /**
         * Defines if the view has to hide the day labels (numbers below the week days).
         * By default false.
         */
        this.hideWeekViewDayLabel = false;
        /**
         * Defines if the view has to scroll to specific hour when it fires onInit event.
         * The input receives the specific hour as an argument.
         */
        this.scrollWeekViewToSpecificHourOnInit = null;
        /**
         * Defines if the view has to scroll to the first event when it fires onInit event.
         */
        this.scrollWeekViewToFirstEventOnInit = false;
        /**
         * Defines if the view has to scroll to the changed event
         */
        this.scrollWeekViewToEventOnChange = false;
        /**
         * Dispatches the dayclick event from the different views across the library.
         */
        this.DayClicked = new EventEmitter();
        /**
         * Defines the event called on a specific shift.
         */
        this.DayEventClicked = new EventEmitter();
        /**
         * Defines the event called on a specific shift.
         */
        this.WeekEventClicked = new EventEmitter();
        /**
         * Defines the event called on a specific shift's remove button.
         */
        this.WeekEventRemove = new EventEmitter();
        /**
         * Defines where the shifts will live.
         */
        this._shiftsStore = new BehaviorSubject([]);
    }
    Object.defineProperty(AngularMaterialSchedulerComponent.prototype, "shifts", {
        /**
         * Defines the array of "Events" the calendar will show.
         */
        set: /**
         * Defines the array of "Events" the calendar will show.
         * @param {?} shifts
         * @return {?}
         */
        function (shifts) {
            this._shiftsStore.next(shifts);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    AngularMaterialSchedulerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} c
     * @return {?}
     */
    AngularMaterialSchedulerComponent.prototype.ngOnChanges = /**
     * @param {?} c
     * @return {?}
     */
    function (c) {
        console.log(c);
    };
    /**
     * @return {?}
     */
    AngularMaterialSchedulerComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        // Check if the input value is ok.
        if (this.date instanceof Date)
            // Configure the current date
            this._currentDate = this.date;
    };
    /**
     * @return {?}
     */
    AngularMaterialSchedulerComponent.prototype.getCurrentMontName = /**
     * @return {?}
     */
    function () {
        if (this.ams.checkIfCanUseIntlFormatter())
            return this.ams.formatDate(this._currentDate, this.locale, { month: "long" });
    };
    AngularMaterialSchedulerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'angular-material-scheduler',
                    template: "\r\n<div class=\"ams-view-wrapper\">\r\n    <ng-container [ngSwitch]=\"view\">\r\n        <angular-material-scheduler-week-view\r\n            *ngSwitchCase=\"'week'\"\r\n            [date]=\"date\"\r\n            [locale]=\"locale\"\r\n            [startOnSunday]=\"startsOnSunday\"\r\n            [shifts]=\"_shiftsStore.value\"\r\n            [scrollWeekViewToEventOnChange]=\"scrollWeekViewToEventOnChange\"\r\n            [scrollWeekViewToFirstEventOnInit]=\"scrollWeekViewToFirstEventOnInit\"\r\n            [scrollWeekViewToSpecificHourOnInit]=\"scrollWeekViewToSpecificHourOnInit\"\r\n            [hideWeekViewDayLabel]=\"hideWeekViewDayLabel\"\r\n            (WeekEventClicked)=\"WeekEventClicked.emit($event)\"\r\n            (WeekEventRemove)=\"WeekEventRemove.emit($event)\">\r\n\r\n        </angular-material-scheduler-week-view>\r\n        <angular-material-scheduler-month-view\r\n            [date]=\"date\"\r\n            [locale]=\"locale\"\r\n            [startOnSunday]=\"startsOnSunday\"\r\n            [shifts]=\"_shiftsStore.value\"\r\n            *ngSwitchCase=\"'month'\"\r\n            (DayClicked)=\"DayClicked.emit($event)\"\r\n            (DayEventClicked)=\"DayEventClicked.emit($event)\">\r\n        </angular-material-scheduler-month-view>\r\n    </ng-container>\r\n</div>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: ["::ng-deepangular-material-scheduler{display:flex;flex-direction:column;flex:1 1 0px;min-height:-webkit-min-content;min-height:-moz-min-content;min-height:min-content}.ams-month-label{text-transform:capitalize}.ams-controls-holder{display:flex;flex-direction:row;min-height:50px}.ams-view-wrapper{display:flex;flex:1 1 0px;flex-direction:row;min-height:-webkit-min-content;min-height:-moz-min-content;min-height:min-content}"]
                }] }
    ];
    /** @nocollapse */
    AngularMaterialSchedulerComponent.ctorParameters = function () { return [
        { type: AngularMaterialSchedulerService }
    ]; };
    AngularMaterialSchedulerComponent.propDecorators = {
        view: [{ type: Input }],
        locale: [{ type: Input }],
        startsOnSunday: [{ type: Input }],
        shifts: [{ type: Input }],
        date: [{ type: Input }],
        hideWeekViewDayLabel: [{ type: Input }],
        scrollWeekViewToSpecificHourOnInit: [{ type: Input }],
        scrollWeekViewToFirstEventOnInit: [{ type: Input }],
        scrollWeekViewToEventOnChange: [{ type: Input }],
        DayClicked: [{ type: Output }],
        DayEventClicked: [{ type: Output }],
        WeekEventClicked: [{ type: Output }],
        WeekEventRemove: [{ type: Output }]
    };
    return AngularMaterialSchedulerComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MonthViewComponent = /** @class */ (function () {
    function MonthViewComponent(ams) {
        this.ams = ams;
        /**
         * Defines the date that the view is going to use. If no argument is passed it will uses new Date()
         */
        this.date = new Date();
        /**
         * Defines if the view will start on Sunday or on Monday. By default true.
         */
        this.startOnSunday = true;
        /**
         * Defines the locale for the view. By default en-us.
         * For more detailed information about the locales, please visit: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl#Locale_identification_and_negotiation
         */
        this.locale = 'es-us';
        /**
         * Defines the event called on day click.
         */
        this.DayClicked = new EventEmitter();
        /**
         * Defines the event called on a specific shift.
         */
        this.DayEventClicked = new EventEmitter();
        /**
         * Defines the structure to print on the view.
         */
        this.monthStruct = [];
    }
    /**
     * @return {?}
     */
    MonthViewComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.weekDaysLabel = this.ams.getDayNameLabelByLocale(this.locale, this.startOnSunday);
        this.monthStruct = this.calculateMonthStruct(this.date);
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    MonthViewComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        // If the date changes then recalculate the structure.
        if (changes.date && changes.date.firstChange == false) {
            this.monthStruct = this.calculateMonthStruct(changes.date.currentValue);
        }
    };
    /**
     * Dispatches the dayclick event from the month view.
     * @param date
     * @param shifts
     */
    /**
     * Dispatches the dayclick event from the month view.
     * @param {?} date
     * @param {?} shifts
     * @return {?}
     */
    MonthViewComponent.prototype.DayClickedOnView = /**
     * Dispatches the dayclick event from the month view.
     * @param {?} date
     * @param {?} shifts
     * @return {?}
     */
    function (date, shifts) {
        this.DayClicked.emit({ date: date, shifts: shifts });
    };
    /**
     * Dispatches the DayEventClick event from the month view.
     * @param date
     * @param shift
     */
    /**
     * Dispatches the DayEventClick event from the month view.
     * @param {?} event
     * @param {?} date
     * @param {?} shift
     * @return {?}
     */
    MonthViewComponent.prototype.DayEventClickedOnView = /**
     * Dispatches the DayEventClick event from the month view.
     * @param {?} event
     * @param {?} date
     * @param {?} shift
     * @return {?}
     */
    function (event, date, shift) {
        // This line is because we have a (click) hierarchy on the dom
        // and if we don't stop the propagation of the mouse event,
        // both DayEventClicked and DayClicked events will fire.
        // we wanna avoid that behavior.
        event.stopPropagation();
        this.DayEventClicked.emit({ date: date, shift: shift });
    };
    /**
     * Build and returns the month structure. It will be used on the view.
     */
    /**
     * Build and returns the month structure. It will be used on the view.
     * @private
     * @param {?} date
     * @return {?}
     */
    MonthViewComponent.prototype.calculateMonthStruct = /**
     * Build and returns the month structure. It will be used on the view.
     * @private
     * @param {?} date
     * @return {?}
     */
    function (date) {
        /** @type {?} */
        var monthStruct = [];
        // First of all we have to know on which day starts the month because we need to
        // left some space blank at the begining or at the end.
        /** @type {?} */
        var firstOfMonth = new Date();
        firstOfMonth.setFullYear(this.date.getFullYear(), this.date.getMonth(), 1);
        /** @type {?} */
        var lastOfMonth = new Date();
        lastOfMonth.setFullYear(this.date.getFullYear(), this.date.getMonth() + 1, 0);
        // date.getDay() gives us the number of whitespaces from the start to the day.
        // if we keep in mind that the week can start on sunday it will be -1.
        /** @type {?} */
        var startPos = firstOfMonth.getDay() - (this.startOnSunday ? -1 : 0);
        /** @type {?} */
        var week = [];
        // WARNING!! if the firstOfMonth.getDay() and startOnSunday equals false, the start pos is 7!
        if (firstOfMonth.getDay() == 0 && !this.startOnSunday) {
            startPos = 7;
        }
        // Fill the spaces on the week
        week = Array(startPos - 1);
        week.fill(0, 0, startPos - 1);
        // Check if the start pos is at the end of the week. Then we have to push it directly into
        // the months structure.
        // if((startPos % 7) == 0)
        // {
        //     week.push(firstOfMonth);
        //     monthStruct.push(week);
        //     week = [];
        // }
        // Let's build the structure.
        startPos -= 1; // That makes easier calculate the real offset for the bucle.
        for (var i = 1; i <= lastOfMonth.getDate(); i++) {
            /** @type {?} */
            var dateOfI = new Date();
            dateOfI.setFullYear(this.date.getFullYear(), this.date.getMonth(), i);
            /** @type {?} */
            var offset = startPos + i;
            if ((offset % 7) == 0 || i == lastOfMonth.getDate()) // The % indicates when we havee to end the current week and start another one.
             {
                week.push(dateOfI);
                monthStruct.push(week);
                week = [];
            }
            else {
                week.push(dateOfI);
            }
        }
        return monthStruct;
    };
    MonthViewComponent.decorators = [
        { type: Component, args: [{
                    selector: 'angular-material-scheduler-month-view',
                    template: "<div class=\"ams-month-view-label-row\">\r\n    <div class=\"ams-month-view-day\" *ngFor=\"let day of weekDaysLabel\">{{day}}</div>\r\n</div>\r\n<div class=\"ams-month-view-row\" *ngFor=\"let week of this.monthStruct\">\r\n    <div *ngFor=\"let day of week\" class=\"ams-month-view-day ams-month-view-day-button\">\r\n        <div *ngIf=\"day\" class=\"ams-month-view-day-content\" (click)=\"DayClickedOnView(day, ams.findShiftsForSpecificDay(day, shifts))\" matRipple>\r\n            <div class=\"ams-month-view-day-label\">{{ day.getDate() }}</div>\r\n            <ng-container *ngIf=\"day\">\r\n                <!-- SHIFTS -->\r\n                <ng-container *ngIf=\"ams.findShiftsForSpecificDay(day, shifts); let shifts\">\r\n                    <div class=\"ams-month-view-day-event {{shifts[0].cssClass}}\" matRipple (click)=\"DayEventClickedOnView($event, day, shifts[0]);\" *ngIf=\"shifts.length > 0\">\r\n                        <div class=\"ams-month-view-day-event-label\">\r\n                            {{shifts[0].title}}\r\n                        </div>\r\n                    </div>\r\n                    <div class=\"ams-month-view-day-event\" matRipple *ngIf=\"shifts.length > 1\">\r\n                        <div class=\"ams-month-view-day-event-label\">\r\n                            {{shifts.length - 1}}+ ...\r\n                        </div>\r\n                    </div>\r\n                </ng-container>\r\n            </ng-container>\r\n        </div>\r\n    </div>\r\n</div>",
                    styles: ["::ng-deepangular-material-scheduler-month-view{display:flex;flex-direction:column;flex:1 1 0px;min-height:100%}.ams-month-view-day{display:flex;flex-direction:column;flex:1 1 0px;min-width:50px;max-width:14.28%}.ams-month-view-day-label{display:flex;flex-direction:row;min-height:15px}.ams-month-view-day-event{display:flex;flex-direction:row;min-height:15px;border-radius:12px;background-color:#5c6bc0;color:#fff;font-size:11px;line-height:1.4;padding:2px 2px 2px 6px;margin-bottom:4px}.ams-month-view-day-event:hover{background-color:#4a569b}.ams-month-view-row{display:flex;flex-direction:row;min-height:50px;flex:1 1 auto;border-bottom:1px solid #d4d4d4}.ams-month-view-label-row{display:flex;flex-direction:row;min-height:30px;border-bottom:1px solid #d4d4d4}.ams-month-view-day-button{cursor:pointer}.ams-month-view-day-button:hover{background-color:rgba(0,0,0,.04)}.ams-month-view-day-content{display:flex;flex-direction:column;height:100%;padding:4px;cursor:pointer}.ams-month-view-day-event-label{text-overflow:ellipsis;overflow:hidden;white-space:nowrap}"]
                }] }
    ];
    /** @nocollapse */
    MonthViewComponent.ctorParameters = function () { return [
        { type: AngularMaterialSchedulerService }
    ]; };
    MonthViewComponent.propDecorators = {
        date: [{ type: Input }],
        startOnSunday: [{ type: Input }],
        locale: [{ type: Input }],
        shifts: [{ type: Input }],
        DayClicked: [{ type: Output }],
        DayEventClicked: [{ type: Output }]
    };
    return MonthViewComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MaterialModule = /** @class */ (function () {
    function MaterialModule() {
    }
    MaterialModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        A11yModule,
                        CdkTableModule,
                        CdkTreeModule,
                        CdkStepperModule,
                        DragDropModule,
                        MatAutocompleteModule,
                        MatBadgeModule,
                        MatBottomSheetModule,
                        MatButtonModule,
                        MatButtonToggleModule,
                        MatCardModule,
                        MatCheckboxModule,
                        MatChipsModule,
                        MatDatepickerModule,
                        MatDialogModule,
                        MatDividerModule,
                        MatExpansionModule,
                        MatFormFieldModule,
                        MatGridListModule,
                        MatIconModule,
                        MatInputModule,
                        MatListModule,
                        MatMenuModule,
                        MatPaginatorModule,
                        MatProgressBarModule,
                        MatProgressSpinnerModule,
                        MatRadioModule,
                        MatRippleModule,
                        MatSelectModule,
                        MatSidenavModule,
                        MatSlideToggleModule,
                        MatSliderModule,
                        MatSnackBarModule,
                        MatSortModule,
                        MatStepperModule,
                        MatTableModule,
                        MatTabsModule,
                        MatToolbarModule,
                        MatTooltipModule,
                        MatTreeModule,
                        ScrollingModule,
                        PortalModule,
                        MatNativeDateModule,
                    ],
                    exports: [
                        A11yModule,
                        CdkTableModule,
                        CdkTreeModule,
                        CdkStepperModule,
                        DragDropModule,
                        MatAutocompleteModule,
                        MatBadgeModule,
                        MatBottomSheetModule,
                        MatButtonModule,
                        MatButtonToggleModule,
                        MatCardModule,
                        MatCheckboxModule,
                        MatChipsModule,
                        MatDatepickerModule,
                        MatDialogModule,
                        MatDividerModule,
                        MatExpansionModule,
                        MatFormFieldModule,
                        MatGridListModule,
                        MatIconModule,
                        MatInputModule,
                        MatListModule,
                        MatMenuModule,
                        MatPaginatorModule,
                        MatProgressBarModule,
                        MatProgressSpinnerModule,
                        MatRadioModule,
                        MatRippleModule,
                        MatSelectModule,
                        MatSidenavModule,
                        MatSlideToggleModule,
                        MatSliderModule,
                        MatSnackBarModule,
                        MatSortModule,
                        MatStepperModule,
                        MatTableModule,
                        MatTabsModule,
                        MatToolbarModule,
                        MatTooltipModule,
                        MatTreeModule,
                        ScrollingModule,
                        PortalModule,
                        MatNativeDateModule,
                    ]
                },] }
    ];
    return MaterialModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var WeekViewComponent = /** @class */ (function () {
    function WeekViewComponent(ams) {
        var _this = this;
        this.ams = ams;
        /**
         * Defines the date that the view is going to use. If no argument is passed it will uses new Date()
         */
        this.date = new Date();
        /**
         * Defines if the view will start on Sunday or on Monday. By default true.
         */
        this.startOnSunday = true;
        /**
         * Defines the locale for the view. By default en-us.
         * For more detailed information about the locales, please visit: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl#Locale_identification_and_negotiation
         */
        this.locale = 'en-us';
        /**
         * Defines if the view has to hide the day labels (numbers below the week days).
         * By default false.
         */
        this.hideWeekViewDayLabel = false;
        /**
         * Defines if the view has to scroll to specific hour when it fires onInit event.
         * The input receives the specific hour as an argument.
         */
        this.scrollWeekViewToSpecificHourOnInit = null;
        /**
         * Defines if the view has to scroll to the first event when it fires onInit event.
         */
        this.scrollWeekViewToFirstEventOnInit = false;
        /**
         * Defines if the view has to scroll to the changed event
         */
        this.scrollWeekViewToEventOnChange = false;
        /**
         * Defines the event called on a specific shift.
         */
        this.WeekEventClicked = new EventEmitter();
        /**
         * Defines the event called on a specific shift's remove button.
         */
        this.WeekEventRemove = new EventEmitter();
        /**
         * Defines the structure to print on the view.
         */
        this.weekStruct = [];
        /**
         * Defines the default offset for the scrollbar in order to align the items on the view.
         */
        this.scrollBarOffset = 17;
        /**
         * Defines where the shifts will live.
         */
        this._shiftsStore = new BehaviorSubject([]);
        this.timeline = Array(48).fill(null).map((/**
         * @param {?} x
         * @param {?} i
         * @return {?}
         */
        function (x, i) {
            /** @type {?} */
            var currentDate = new Date();
            currentDate.setHours(0, 0, 0);
            currentDate = _this.ams.increaseHoursToSpecificDate(currentDate, i / 2); // Divided by 2 because we wanna step every half hour.
            // Divided by 2 because we wanna step every half hour.
            /** @type {?} */
            var hourParts = currentDate.toTimeString().split(":");
            return { date: currentDate, hourStr: hourParts[0] + ":" + hourParts[1], idx: i };
        }));
    }
    Object.defineProperty(WeekViewComponent.prototype, "shifts", {
        /**
         * Defines the array of events.
         */
        set: /**
         * Defines the array of events.
         * @param {?} shifts
         * @return {?}
         */
        function (shifts) {
            this._shiftsStore.next(shifts);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    WeekViewComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.weekDaysLabel = this.ams.getDayNameLabelByLocale(this.locale, this.startOnSunday);
        this.weekStruct = this.calculateWeekStructure(this.date);
        this.scrollBarOffset = this.ams.getScrollbarWidth();
    };
    /**
     * @return {?}
     */
    WeekViewComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.handleScrollToSpecificHour();
        this.handleScrollToFirstEventOnInit();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    WeekViewComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        // If the date changes then recalculate the structure.
        if (changes.date && changes.date.firstChange == false) {
            this.weekStruct = this.calculateWeekStructure(changes.date.currentValue);
        }
    };
    /**
     * @return {?}
     */
    WeekViewComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this._subscription)
            this._subscription.unsubscribe();
    };
    /**
     * Finds the shifts for specific range of hours and prepare them for rendering into the view
     */
    /**
     * Finds the shifts for specific range of hours and prepare them for rendering into the view
     * @param {?} day
     * @param {?} timelineIdx
     * @param {?} cell
     * @return {?}
     */
    WeekViewComponent.prototype.calculateShiftForSpecificDay = /**
     * Finds the shifts for specific range of hours and prepare them for rendering into the view
     * @param {?} day
     * @param {?} timelineIdx
     * @param {?} cell
     * @return {?}
     */
    function (day, timelineIdx, cell) {
        var _this = this;
        day.setHours(0, 0, 0);
        /** @type {?} */
        var dateIni = new Date(day.toDateString());
        // Remove ref
        /** @type {?} */
        var dateEnd = new Date(day.toDateString());
        dateEnd = new Date(dateEnd.getTime() - (1 * 60000)); // Substract a minute.
        dateIni = this.ams.increaseHoursToSpecificDate(dateIni, (timelineIdx / 2));
        dateEnd = this.ams.increaseHoursToSpecificDate(dateEnd, (timelineIdx / 2) + TIME_OFFSET_BETWEEN_HOURS_IN_TIMELINE);
        /** @type {?} */
        var shifts = this.ams.findShiftsForSpecificRangeOfHours(dateIni, dateEnd, this._shiftsStore.value);
        /** @type {?} */
        var preparedShifts = [];
        shifts.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            // For the height:
            // Calculate the difference (in hours) between the 2 dates, ini and end.
            // After that, multiply that value by the height of 30 min (there is a constant defined at the end)
            // We have to ensure the value isn't less than the value of the constant.
            // if not equals or greater than that we have to obviate the value
            // and use the constant as height
            /** @type {?} */
            var heightFactor = _this.ams.calculateHoursBetweenTwoDates(x.dateIni, x.dateEnd);
            /** @type {?} */
            var height = (heightFactor * TIMELINE_OFFSET_TOP_SPACE_BETWEEN_HOURS);
            height = height < TIMELINE_OFFSET_TOP_SPACE_BETWEEN_HOURS ? TIMELINE_OFFSET_TOP_SPACE_BETWEEN_HOURS : height;
            /** @type {?} */
            var preparedShift = (/** @type {?} */ ({
                id: x.id,
                dateIni: x.dateIni,
                dateEnd: x.dateEnd,
                title: x.title,
                width: 80,
                height: height // TODO: Calculate using the comment
            }));
            preparedShifts.push(preparedShift);
        }));
        return preparedShifts;
    };
    /**
     * Used to identify the elements on the *ngFor.
     */
    /**
     * Used to identify the elements on the *ngFor.
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    WeekViewComponent.prototype.identy = /**
     * Used to identify the elements on the *ngFor.
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    function (index, item) {
        return index;
    };
    /**
     * Fires the shift clicked event to the parent.
     */
    /**
     * Fires the shift clicked event to the parent.
     * @param {?} date
     * @param {?} shift
     * @return {?}
     */
    WeekViewComponent.prototype.ShiftClicked = /**
     * Fires the shift clicked event to the parent.
     * @param {?} date
     * @param {?} shift
     * @return {?}
     */
    function (date, shift) {
        this.WeekEventClicked.emit((/** @type {?} */ ({
            date: date,
            shift: shift
        })));
    };
    /**
     * Fires the shift removed event to the parent.
     */
    /**
     * Fires the shift removed event to the parent.
     * @param {?} shift
     * @return {?}
     */
    WeekViewComponent.prototype.ShiftRemove = /**
     * Fires the shift removed event to the parent.
     * @param {?} shift
     * @return {?}
     */
    function (shift) {
        this.WeekEventRemove.emit((/** @type {?} */ ({
            shift: shift
        })));
    };
    /**
     * Build and returns the week structured. It will be used on the view.
     */
    /**
     * Build and returns the week structured. It will be used on the view.
     * @private
     * @param {?} date
     * @return {?}
     */
    WeekViewComponent.prototype.calculateWeekStructure = /**
     * Build and returns the week structured. It will be used on the view.
     * @private
     * @param {?} date
     * @return {?}
     */
    function (date) {
        // Given an specific date, let's take the current week.
        // then, calculate which is its first day.
        /** @type {?} */
        var weekStruct = [];
        /** @type {?} */
        var firstOfWeek = this.ams.getFirstOfWeek(date, this.startOnSunday);
        weekStruct.push(firstOfWeek);
        // Now iterate over the week's days and mount the structure.
        for (var i = 1; i < 7; i++) {
            /** @type {?} */
            var nextDay = new Date(firstOfWeek.toDateString());
            nextDay.setDate(firstOfWeek.getDate() + i);
            weekStruct.push(nextDay);
        }
        return weekStruct;
    };
    /**
     * Handle if the view has to scroll to the first event on view has init.
     */
    /**
     * Handle if the view has to scroll to the first event on view has init.
     * @private
     * @return {?}
     */
    WeekViewComponent.prototype.handleScrollToFirstEventOnInit = /**
     * Handle if the view has to scroll to the first event on view has init.
     * @private
     * @return {?}
     */
    function () {
        if (this.scrollWeekViewToFirstEventOnInit && this._shiftsStore.value.length > 0) {
            // Find the shifts that are inside this week.
            /** @type {?} */
            var firstOfWeek = this.ams.getFirstOfWeek(this.date, this.startOnSunday);
            // Configure the dates and its hours to find the shifts for that week.
            firstOfWeek.setHours(0, 0, 0);
            /** @type {?} */
            var endOfWeek = new Date(firstOfWeek.getTime());
            endOfWeek.setHours(23, 59, 59);
            endOfWeek = this.ams.increaseHoursToSpecificDate(endOfWeek, 24 * 6);
            // Filter the shifts array and try to scroll to the first one.
            /** @type {?} */
            var filteredShifts = this.ams.findShiftsForSpecificRange(firstOfWeek, endOfWeek, this._shiftsStore.value);
            if (filteredShifts.length > 0) {
                /** @type {?} */
                var firstShift = filteredShifts[0];
                /** @type {?} */
                var domShift = document.getElementById("" + firstShift.id);
                if (domShift) {
                    this.ams.scrollContentTo(this.timelineScroller.nativeElement, 0, domShift.parentElement.parentElement.offsetTop - (TIMELINE_OFFSET_TOP_SPACE_BETWEEN_HOURS / 2));
                }
            }
        }
    };
    /**
     * @private
     * @return {?}
     */
    WeekViewComponent.prototype.handleScrollToSpecificHour = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.scrollWeekViewToSpecificHourOnInit) {
            /** @type {?} */
            var hourToScroll = document.getElementById(this.scrollWeekViewToSpecificHourOnInit.toString());
            if (hourToScroll) {
                this.ams.scrollContentTo(this.timelineScroller.nativeElement, 0, hourToScroll.offsetTop - (TIMELINE_OFFSET_TOP_SPACE_BETWEEN_HOURS / 2));
            }
        }
    };
    WeekViewComponent.decorators = [
        { type: Component, args: [{
                    selector: 'angular-material-scheduler-week-view',
                    template: "<div class=\"ams-week-view-label-row\" [style.paddingRight.px]=\"scrollBarOffset\">\r\n    <div class=\"ams-week-view-day\"></div>\r\n    <div class=\"ams-week-view-day\" *ngFor=\"let day of weekStruct\">\r\n        <div class=\"ams-week-view-timeline-event-content\">\r\n            <div>{{ams.getShortDayNameForSpecificDay(day, locale)}}</div>\r\n            <div *ngIf=\"!hideWeekViewDayLabel\">{{day.getDate()}}</div>\r\n        </div>\r\n    </div>\r\n</div>\r\n<div #timelineScroller class=\"ams-week-view-timeline\">\r\n    <div class=\"ams-week-view-timeline-container\">\r\n        <div class=\"ams-week-view-timeline-row\" *ngFor=\"let timeDef of timeline\" [id]=\"timeDef.hourStr\">\r\n            <div class=\"ams-week-view-timeline-column\">\r\n                <div class=\"ams-week-view-timeline-event-content\">{{timeDef.hourStr}}</div>\r\n            </div>\r\n            <div class=\"ams-week-view-timeline-column ams-pad0\" *ngFor=\"let day of weekStruct\">\r\n                <ng-container *ngIf=\"calculateShiftForSpecificDay(day, timeDef.idx, null); let dayShifts\">\r\n                    <div\r\n                        (mouseover)=\"delete.style.visibility = 'visible'\"\r\n                        (mouseout)=\"delete.style.visibility = 'hidden'\"\r\n                        *ngFor=\"let shift of dayShifts;let i = index; trackBy: identy\"\r\n                        class=\"ams-week-view-timeline-event mat-elevation-z3\"\r\n                        [style.width.px]=\"shift.width\"\r\n                        [style.height.px]=\"shift.height\">\r\n                        <div [id]=\"shift.id\" (click)=\"ShiftClicked(day, shift)\" matRipple class=\"ams-week-view-event-container\">\r\n                            <div class=\"ams-week-view-timeline-event-content\">{{ shift.title }}</div>\r\n                        </div>\r\n                        <div #delete class=\"ams-week-view-event-remove-button\">\r\n                            <button color=\"warn\" (click)=\"ShiftRemove(shift)\" mat-mini-fab>\r\n                                <mat-icon>delete</mat-icon>\r\n                            </button>\r\n                        </div>\r\n                    </div>\r\n                </ng-container>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: ["::ng-deepangular-material-scheduler-week-view{display:flex;flex-direction:column;flex:1 1 0px;min-height:100%}.ams-week-view-label-row{display:flex;flex-direction:row;min-height:50px;border-bottom:1px solid #d4d4d4}.ams-week-view-day,.ams-week-view-timeline-column{display:flex;flex-direction:column;flex:1 1 0px;min-width:50px;border-right:1px solid #d4d4d4;position:relative}.ams-week-view-column-mar{margin-left:12px}.ams-week-view-timeline{display:flex;flex-direction:row;flex:1 1 0px;overflow-y:auto}.ams-week-view-timeline-container{display:flex;flex-direction:column;flex:1 1 auto}.ams-week-view-timeline-row{display:flex;flex-direction:row;min-height:50px;max-height:50px}.ams-week-view-timeline-row:nth-child(even){background-color:#eeeeee48}.ams-week-view-timeline-row:nth-child(odd){background-color:transparent}.ams-week-view-timeline-event{position:absolute;background-color:#4a569b;border-radius:12px;font-size:11px;line-height:1.4;color:#fff;z-index:1}.ams-week-view-timeline-event-content{margin:6px}.ams-pad0{padding:0!important}.ams-week-view-event-container{display:flex;flex-direction:column;flex:1 1 0px;min-height:100%;z-index:1;cursor:pointer}.ams-week-view-event-remove-button{visibility:hidden;position:absolute;right:-16px;top:-16px;z-index:2}"]
                }] }
    ];
    /** @nocollapse */
    WeekViewComponent.ctorParameters = function () { return [
        { type: AngularMaterialSchedulerService }
    ]; };
    WeekViewComponent.propDecorators = {
        date: [{ type: Input }],
        startOnSunday: [{ type: Input }],
        locale: [{ type: Input }],
        shifts: [{ type: Input }],
        hideWeekViewDayLabel: [{ type: Input }],
        scrollWeekViewToSpecificHourOnInit: [{ type: Input }],
        scrollWeekViewToFirstEventOnInit: [{ type: Input }],
        scrollWeekViewToEventOnChange: [{ type: Input }],
        WeekEventClicked: [{ type: Output }],
        WeekEventRemove: [{ type: Output }],
        timelineScroller: [{ type: ViewChild, args: ['timelineScroller', { static: true },] }]
    };
    return WeekViewComponent;
}());
/** @type {?} */
var TIME_OFFSET_BETWEEN_HOURS_IN_TIMELINE = 0.5;
// that value is equal 30min.
/** @type {?} */
var TIMELINE_OFFSET_TOP_SPACE_BETWEEN_HOURS = 100;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularMaterialSchedulerModule = /** @class */ (function () {
    function AngularMaterialSchedulerModule() {
    }
    AngularMaterialSchedulerModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [AngularMaterialSchedulerComponent, MonthViewComponent, WeekViewComponent],
                    imports: [CommonModule, MaterialModule],
                    exports: [AngularMaterialSchedulerComponent]
                },] }
    ];
    return AngularMaterialSchedulerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AngularMaterialSchedulerComponent, AngularMaterialSchedulerModule, AngularMaterialSchedulerService, MonthViewComponent as ɵa, WeekViewComponent as ɵb, MaterialModule as ɵc };
//# sourceMappingURL=angular-material-scheduler.js.map
